# Changelog

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

### [0.6.1](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.6.0...v0.6.1) (2021-02-08)


### Bug Fixes

* **object-core:** Strip void type during object optional reflection ([05dd7da](https://gitlab.com/SyntheticGoop/hyperval/commit/05dd7da24f052bde2343b1efdd938b332115fc5c))

## [0.6.0](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.5.3...v0.6.0) (2021-02-02)


### Features

* **object:** Strip all top level optional object properties which are undefined ([d38aa05](https://gitlab.com/SyntheticGoop/hyperval/commit/d38aa056f6b9ae0028e5168a0cf8687839af964c))

### [0.5.3](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.5.2...v0.5.3) (2021-01-31)

### [0.5.2](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.5.1...v0.5.2) (2021-01-30)


### Features

* **Hyper:** Use 'strict' as the second argument to trick the overload ([7ec4464](https://gitlab.com/SyntheticGoop/hyperval/commit/7ec4464ed02c3e7fde759d0e5c40e02998f30de8))


### Bug Fixes

* **optional:** Optional on objects should make keys optional ([e68bf80](https://gitlab.com/SyntheticGoop/hyperval/commit/e68bf80ff337304c10e3b872db56097a3fc38dd4))

### [0.5.1](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.5.0...v0.5.1) (2021-01-30)


### Features

* Export composite, composer and modifier types ([883a2aa](https://gitlab.com/SyntheticGoop/hyperval/commit/883a2aa53a70a66b12a8c9576f56c16c57db7dbf))

## [0.5.0](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.4.2...v0.5.0) (2021-01-26)


### Features

* Add unknown validator ([115490c](https://gitlab.com/SyntheticGoop/hyperval/commit/115490c614416246ef2020f888c812cde7616cac))

### [0.4.2](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.4.1...v0.4.2) (2021-01-22)


### Bug Fixes

* **custom:** Fix custom typings ([c293699](https://gitlab.com/SyntheticGoop/hyperval/commit/c2936990f030976140efb482209254216e0334f2))

### [0.4.1](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.4.0...v0.4.1) (2021-01-22)


### Bug Fixes

* **Hyper:** Allow then validators to take in non promises ([b2fae26](https://gitlab.com/SyntheticGoop/hyperval/commit/b2fae2638946fb5e4695238fe16e32c8a7d1a5b7))
* **Hyper:** Bind validation function to object. Add corresponding tests. ([aaec2a7](https://gitlab.com/SyntheticGoop/hyperval/commit/aaec2a73b708fb4affbb58856c29edb0a0df6bc8))
* **Trace:** Enable destructuring of trace class ([97d2513](https://gitlab.com/SyntheticGoop/hyperval/commit/97d25134b4b6fd837b57d280311e868095d4efc6))

## [0.4.0](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.3.0...v0.4.0) (2021-01-22)


### Features

* **Hyper:** Add promise validators ([691d58f](https://gitlab.com/SyntheticGoop/hyperval/commit/691d58fa9118b42e52dde0a1c2f155a12517c1ba))

## [0.3.0](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.0.2...v0.3.0) (2021-01-22)


### Features

* Add any typecheckers to Hyper ([1a910ca](https://gitlab.com/SyntheticGoop/hyperval/commit/1a910caa522af347df47ecc24c899f38f63ca6ed))
* Deprecate any versions of validation methods in favor of overloads ([a666a33](https://gitlab.com/SyntheticGoop/hyperval/commit/a666a333328603ee133ce57118c0c3f57a8cd586))
* Deprecate Hyperval and Hyperraw for HyperVal and HyperOut ([1a4720e](https://gitlab.com/SyntheticGoop/hyperval/commit/1a4720e0e1b3cb4d935c510ba5f1cc51ae9e681a))


### Bug Fixes

* **alter:** Fix input type using Val instead of Raw ([fa2b3e0](https://gitlab.com/SyntheticGoop/hyperval/commit/fa2b3e04139d4dc7eca649c36ccc02158d968e09))
* **alter:** Fix typing for curried function ([7c0a2b5](https://gitlab.com/SyntheticGoop/hyperval/commit/7c0a2b586bef0a1b23bc06025d8ec99cf75f3308))
* **func:** Allow default function type to be overloaded ([fc05c1d](https://gitlab.com/SyntheticGoop/hyperval/commit/fc05c1da7cf452f4e1ceb7595e4bf556ae05f806))
* **Hyper:** Allow Hyper to be destructured ([f392163](https://gitlab.com/SyntheticGoop/hyperval/commit/f392163f567b30c960e6b43e67915648b4a8a1b8))
* **typescript:** Export all internal classes ([b107a5e](https://gitlab.com/SyntheticGoop/hyperval/commit/b107a5e2cbb62c17861eb2f441317bb8c5c9f445))

### [0.2.7](https://gitlab.com/SyntheticGoop/hyperval/compare/v0.0.2...v0.2.7) (2021-01-22)


### Features

* Add any typecheckers to Hyper ([1a910ca](https://gitlab.com/SyntheticGoop/hyperval/commit/1a910caa522af347df47ecc24c899f38f63ca6ed))
* Deprecate Hyperval and Hyperraw for HyperVal and HyperOut ([1a4720e](https://gitlab.com/SyntheticGoop/hyperval/commit/1a4720e0e1b3cb4d935c510ba5f1cc51ae9e681a))


### Bug Fixes

* **alter:** Fix input type using Val instead of Raw ([fa2b3e0](https://gitlab.com/SyntheticGoop/hyperval/commit/fa2b3e04139d4dc7eca649c36ccc02158d968e09))
* **alter:** Fix typing for curried function ([7c0a2b5](https://gitlab.com/SyntheticGoop/hyperval/commit/7c0a2b586bef0a1b23bc06025d8ec99cf75f3308))
* **func:** Allow default function type to be overloaded ([fc05c1d](https://gitlab.com/SyntheticGoop/hyperval/commit/fc05c1da7cf452f4e1ceb7595e4bf556ae05f806))
* **Hyper:** Allow Hyper to be destructured ([f392163](https://gitlab.com/SyntheticGoop/hyperval/commit/f392163f567b30c960e6b43e67915648b4a8a1b8))
* **typescript:** Export all internal classes ([b107a5e](https://gitlab.com/SyntheticGoop/hyperval/commit/b107a5e2cbb62c17861eb2f441317bb8c5c9f445))
